package org.lazywizard.console.commands;

import com.fs.starfarer.api.EveryFrameScript;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.CampaignUIAPI;
import com.fs.starfarer.api.combat.ViewportAPI;
import org.lazywizard.console.BaseCommand;
import org.lazywizard.console.CommonStrings;
import org.lazywizard.console.Console;
import org.lwjgl.input.Mouse;

public class Test implements BaseCommand
{
    @Override
    public CommandResult runCommand(String args, CommandContext context)
    {
        if (!context.isInCampaign())
        {
            Console.showMessage(CommonStrings.ERROR_CAMPAIGN_ONLY);
            return CommandResult.WRONG_CONTEXT;
        }

        Global.getSector().addTransientScript(new TestScript());
        Console.showMessage("You've done something, but you're not sure what...");
        return CommandResult.SUCCESS;
    }

    private static class TestScript implements EveryFrameScript
    {
        boolean buttonDown = false;

        @Override
        public boolean isDone()
        {
            return false;
        }

        @Override
        public boolean runWhilePaused()
        {
            return true;
        }

        @Override
        public void advance(float amount)
        {
            final CampaignUIAPI ui = Global.getSector().getCampaignUI();
            if (ui.isShowingDialog() || ui.isShowingMenu())
            {
                return;
            }

            if (Mouse.isButtonDown(0))
            {
                if (!buttonDown)
                {
                    buttonDown = true;
                    final ViewportAPI view = Global.getSector().getViewport();
                    final float x = view.convertScreenXToWorldX(Mouse.getX()),
                            y = view.convertScreenYToWorldY(Mouse.getY());
                    Global.getSector().getCurrentLocation().addCustomEntity(
                            null, "TEST", "orbital_junk", "player")
                            .setFixedLocation(x, y);
                }
            }
            else
            {
                buttonDown = false;
            }
        }
    }
}
